#!/usr/bin/env sh

set -eu

get_version() {
    grep -P '^export FLOORP_VERSION =' GNUmakefile | sed 's/^export FLOORP_VERSION = //'
}

get_release() {
    grep -P '^export FIREDRAGON_RELEASE =' GNUmakefile | sed 's/^export FIREDRAGON_RELEASE = //'
}

# @getoptions
parser_definition() {
  setup REST help:help -- 'Usage: release.sh [options]...'
  msg --
  msg -- 'Options:'
  param VERSION -v --version init:'VERSION="$(get_version)"' -- 'Set Floorp version'
  param RELEASE -r --release init:'RELEASE="$(get_release)"' -- 'Set FireDragon release'
  disp :help -h --help -- 'Show help'
}
# @end

# @gengetoptions parser -i parser_definition parse
# Generated by getoptions (BEGIN)
# URL: https://github.com/ko1nksm/getoptions (v3.3.0)
VERSION="$(get_version)"
RELEASE="$(get_release)"
REST=''
parse() {
  OPTIND=$(($#+1))
  while OPTARG= && [ $# -gt 0 ]; do
    case $1 in
      --?*=*) OPTARG=$1; shift
        eval 'set -- "${OPTARG%%\=*}" "${OPTARG#*\=}"' ${1+'"$@"'}
        ;;
      --no-*|--without-*) unset OPTARG ;;
      -[vr]?*) OPTARG=$1; shift
        eval 'set -- "${OPTARG%"${OPTARG#??}"}" "${OPTARG#??}"' ${1+'"$@"'}
        ;;
      -[h]?*) OPTARG=$1; shift
        eval 'set -- "${OPTARG%"${OPTARG#??}"}" -"${OPTARG#??}"' ${1+'"$@"'}
        OPTARG= ;;
    esac
    case $1 in
      '-v'|'--version')
        [ $# -le 1 ] && set "required" "$1" && break
        OPTARG=$2
        VERSION="$OPTARG"
        shift ;;
      '-r'|'--release')
        [ $# -le 1 ] && set "required" "$1" && break
        OPTARG=$2
        RELEASE="$OPTARG"
        shift ;;
      '-h'|'--help')
        help
        exit 0 ;;
      --)
        shift
        while [ $# -gt 0 ]; do
          REST="${REST} \"\${$(($OPTIND-$#))}\""
          shift
        done
        break ;;
      [-]?*) set "unknown" "$1"; break ;;
      *)
        REST="${REST} \"\${$(($OPTIND-$#))}\""
    esac
    shift
  done
  [ $# -eq 0 ] && { OPTIND=1; unset OPTARG; return 0; }
  case $1 in
    unknown) set "Unrecognized option: $2" "$@" ;;
    noarg) set "Does not allow an argument: $2" "$@" ;;
    required) set "Requires an argument: $2" "$@" ;;
    pattern:*) set "Does not match the pattern (${1#*:}): $2" "$@" ;;
    notcmd) set "Not a command: $2" "$@" ;;
    *) set "Validation error ($1): $2" "$@"
  esac
  echo "$1" >&2
  exit 1
}
help() {
cat<<'GETOPTIONSHERE'
Usage: release.sh [options]...

Options:
  -v, --version VERSION       Set Floorp version
  -r, --release RELEASE       Set FireDragon release
  -h, --help                  Show help
GETOPTIONSHERE
}
# Generated by getoptions (END)
# @end

parse "$@"
set -- "$REST"

tag="v$VERSION-$RELEASE"
printf 'Releasing %s...\n' "$tag"

if [ "$(git tag -l "$tag")" ]; then
  printf 'Tag already exists. Aborting...\n'
  exit 1
fi

sed -i "s/^export FLOORP_VERSION = .*$/export FLOORP_VERSION = $VERSION/" GNUmakefile
sed -i "s/^export FIREDRAGON_RELEASE = .*$/export FIREDRAGON_RELEASE = $RELEASE/" GNUmakefile

git-cliff -u -t "$tag" -p CHANGELOG.md

git add GNUmakefile CHANGELOG.md
git commit -m "release: $tag"
git tag -m "$tag" "$tag"
